<template>
  <div>
    <div
      class="contact-container"
      :dir="rtlDesginHandler ? 'rtl' : 'ltr'"
      @click="openPopUp($event)"
    >
      <ion-text class="avatar" :class="[item.avatarClass]"
        >{{ item.firstChar }}
        <img
          v-if="gettingImage"
          class="avatar-image"
          :src="gettingImage"
          @load="imageProfileLoaded"
        />
      </ion-text>
      <div class="content">
        <div class="user-information">
          <div
            class="user-information-title"
            :class="[
              {
                'text-direction-right': item?.textDirectionIsRight,
                'text-direction-left': item?.textDirectionIsRight == false,
              },
            ]"
          >
            {{ contactName }}
          </div>
          <div class="time" v-if="showLastSeen">
            <span v-if="item.lastSeen">
              <span v-if="item.lastSeen.isYesterday">
                {{ t('tabs.contacts.lastSeen') }}&nbsp;{{
                  t('tabs.contacts.yesterday')
                }}&nbsp;{{ item.lastSeen.value }}</span
              >
              <span v-else-if="item.lastSeen">
                {{ t('tabs.contacts.lastSeen', { time: item.lastSeen }) }}</span
              >
            </span>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script setup>
import contactPopUp from '@/components/desktop/contacts/contactPopUp.vue';
import { IonText, popoverController } from '@ionic/vue';
import { computed, onMounted, defineProps, defineEmits, ref } from 'vue';
import { useFileManagerStore } from '@/store/fileManager/fileManager.js';
import { useI18n } from 'vue-i18n';
import { useContactsStore } from '@/store/contacts/contacts';
const { t, locale } = useI18n();

const contactsStore = useContactsStore();

const props = defineProps({
  item: {
    type: Object,
  },
  showLastSeen: {
    type: Boolean,
    default: true,
  },
});

const contactName = computed(() => {
  if (props.item.name) {
    if (props.item.name.length > 30) {
      return props.item.name.slice(0, 30) + '...';
    } else {
      return props.item.name;
    }
  }
});

const openPopUp = async (event) => {
  console.log('tuched?');
  event.preventDefault();
  const popover = await popoverController.create({
    component: contactPopUp,
    event: event,
  });
  await popover.present();
  contactsStore.updateSelectedConatct(props.item);
};

const gettingImage = computed(() => {
  const avatarFileId = props.item.avatarFileId;
  const fileManagerStore = useFileManagerStore();
  const image = fileManagerStore.usersAvatarBlobList[avatarFileId];
  if (image && image.thumbnailFile) {
    return image.thumbnailFile;
  }
  return false;
});

const emit = defineEmits(['getAddionalProfileInfo']);

const rtlDesginHandler = computed(() => {
  {
    if (locale.value == 'fa') {
      return true;
    } else {
      return false;
    }
  }
});

onMounted(() => {
  emit('getAddionalProfileInfo', props.item);
});
</script>

<style scoped>
.pop-up-container {
  width: 100%;
  height: 100vh;
  position: fixed;
  z-index: 1;
  top: 0;
  bottom: 0;
  left: 0;
  right: 0;
  background: rgba(158, 155, 155, 0);
  display: flex;
  overflow: hidden;
}

.pop-up-content {
  width: 180px;
  display: flex;
  flex-direction: column;
  position: absolute;
  z-index: 1;
  background: #fff;
  border-radius: 5px;
  padding: 10px 15px;
  cursor: pointer;
}

.pop-up-content span {
  font-size: 14px;
  font-style: normal;
  font-weight: 700;
  line-height: normal;
}
.contact-container {
  display: flex;
  align-items: center;
  justify-content: flex-start;
  gap: 16px;
  cursor: pointer;
}
.content {
  display: flex;
  align-items: center;
  justify-content: space-between;
  gap: 10px;
  width: 100%;
  font-size: 20px;
  font-weight: 600;
  padding: 0px 0;
}
.avatar {
  font-size: 32px;
  min-width: 50px;
  min-height: 50px;
  max-width: 70px;
  max-height: 70px;
  border-radius: 50%;
  text-align: center;
  color: white;
  position: relative;
  overflow: hidden;
}
.avatar-image {
  position: absolute;
  top: 0;
  left: 0;
  width: 100%;
  height: 100%;
  opacity: 1;
  transition: 1s;
  object-fit: cover;
  border-radius: 50%;
}
.avatar-image-loaded {
  opacity: 1;
}
.avatar-image-loaded-without-anim {
  opacity: 1;
}
.user-information-title {
  direction: ltr;
  text-align: left;
  text-overflow: ellipsis;
  white-space: nowrap;
  overflow: hidden;
  max-width: 72vw;
}
.font-farsi .user-information-title {
  text-align: right;
}
.time {
  font-size: 12px;
  color: var(--ion-color-medium);
  min-height: 20px;
}
</style>
